package com.gct.edge.actuator.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.gct.edge.actuator.entity.DiagnoseResultRealTime;
import com.gct.edge.actuator.entity.YieldRealTime;
import com.gct.edge.actuator.mapper.DiagnoseResultRealTimeMapper;
import com.gct.edge.actuator.mapper.YieldDailyMapper;
import com.gct.edge.actuator.mapper.YieldRealTimeMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.ApplicationArguments;
import org.springframework.boot.ApplicationRunner;
import org.springframework.stereotype.Service;

import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.List;
import java.util.Objects;
import java.util.UUID;

/**
 * @author xusirui 2023/7/26
 */
//@Service
public class DataFixService implements ApplicationRunner {

    @Autowired
    YieldRealTimeMapper yieldRealTimeMapper;

    @Autowired
    DiagnoseResultRealTimeMapper diagnoseResultRealTimeMapper;

    DateTimeFormatter df = DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss");

    private void fixYu606_2(){
        LambdaQueryWrapper<YieldRealTime> wrapper = new LambdaQueryWrapper<YieldRealTime>().eq(YieldRealTime::getModuleKey, "module13")
                .gt(YieldRealTime::getProTime, LocalDateTime.parse("2023-07-20 00:00:00",df))
                .lt(YieldRealTime::getProTime, LocalDateTime.parse("2023-07-23 00:00:00",df));
        List<YieldRealTime> data20_23 = yieldRealTimeMapper.selectList(wrapper);
        data20_23.forEach(data->{
            data.setId(UUID.randomUUID().toString());
            data.setProTime(data.getProTime().plusDays(3));
            if (Objects.isNull(yieldRealTimeMapper.selectOne(new LambdaQueryWrapper<YieldRealTime>()
            .eq(YieldRealTime::getModuleKey,data.getModuleKey())
            .eq(YieldRealTime::getProTime,data.getProTime()))))
            yieldRealTimeMapper.insert(data);
        });

        LambdaQueryWrapper<DiagnoseResultRealTime> wrapper2 = new LambdaQueryWrapper<DiagnoseResultRealTime>().eq(DiagnoseResultRealTime::getModuleKey, "module13")
                .gt(DiagnoseResultRealTime::getProTime, LocalDateTime.parse("2023-07-20 00:00:00",df))
                .lt(DiagnoseResultRealTime::getProTime, LocalDateTime.parse("2023-07-23 00:00:00",df));
        List<DiagnoseResultRealTime> gt_data20_23 = diagnoseResultRealTimeMapper.selectList(wrapper2);
        gt_data20_23.forEach(data->{
            data.setProTime(data.getProTime().plusDays(3));
            data.setId(UUID.randomUUID().toString());
            if (Objects.isNull(diagnoseResultRealTimeMapper.selectOne(new LambdaQueryWrapper<DiagnoseResultRealTime>()
                    .eq(DiagnoseResultRealTime::getModuleKey,data.getModuleKey())
                    .eq(DiagnoseResultRealTime::getProTime,data.getProTime()))))
                diagnoseResultRealTimeMapper.insert(data);
        });
    }

    @Override
    public void run(ApplicationArguments args) throws Exception {
        System.out.println("do it");
        fixYu606_2();
        System.exit(0);
    }
}
