import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.gct.common.util.DateTimeUtil;
import com.gct.edge.actuator.EdgeModuleActuatorApplication;
import com.gct.edge.actuator.entity.DiagnoseResultRealTime;
import com.gct.edge.actuator.entity.FileParseObject;
import com.gct.edge.actuator.entity.GtcvrRuntimeConfig;
import com.gct.edge.actuator.service.DiagnoseService;
import com.gct.edge.actuator.service.GtcvrRuntimeConfigService;
import com.gct.edge.actuator.util.DataTranslator;
import com.gct.edge.base.entity.TableNameEnum;
import lombok.experimental.Accessors;
import lombok.extern.slf4j.Slf4j;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringRunner;

import java.io.File;
import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.List;

/**
 * @author xusirui 2021/10/27
 */
@Slf4j
@SpringBootTest(classes = EdgeModuleActuatorApplication.class)
@RunWith(SpringRunner.class)
@ContextConfiguration
public class ActuatorTest {

    @Autowired
    DiagnoseService diagnoseService;
    @Autowired
    GtcvrRuntimeConfigService gtcvrRuntimeConfigService;

    @Test
    public void loadDataTest(){
        GtcvrRuntimeConfig gtcvrRuntimeConfig = new GtcvrRuntimeConfig();
        gtcvrRuntimeConfig.setModuleKey("module4");
        gtcvrRuntimeConfig.setProTime(DateTimeUtil.formatDateTime("2021-12-05 00:00:00"));
//        gtcvrRuntimeConfigService.SaveGtcvrRuntimeConfig(gtcvrRuntimeConfig);
    }


    @Test
    public void testQueryDaya(){
        diagnoseService.list(new QueryWrapper<DiagnoseResultRealTime>()
                .in("module_key", Arrays.asList("module1","module2"))
                .eq("pro_time", DateTimeUtil.formatDateTime("2021-10-01 00:00:00")));
    }

    @Test
    public void testGtOverlay(){
        String beginDate = "2024-05-25 00:00:00";
        String end = "2024-05-25 00:00:00";
        String prePageDate = null;
        Integer pageNum = 1;
        while (true){
            JSONObject res = diagnoseService.getGtOverlayDataLazy("module17", "1", "2024-05-29 00:00:00", "2024-06-04 00:00:00", 12, 0, prePageDate, 24);
            JSONArray list = res.getJSONArray("res");
            if (list.isEmpty())return;
            System.out.println(prePageDate);
            System.out.println(" ------------------------------ page num "+(pageNum++)+"page size"+list.size()+" ------------------------------");
            for (int i = 0; i < list.size(); i++) {
                String proTime = list.getJSONObject(i).getString("proTime");
                System.out.println(proTime.substring(0,10)+" "+proTime.substring(11));
            }
            String lastTime = list.getJSONObject(list.size() - 1).getString("proTime");
            prePageDate = lastTime.substring(0,10)+" "+lastTime.substring(11);
        }
    }
}
